
/* new-gtk2, version 02 */
/* ArktisWM, 2020, GNU GPL3 */

#include <glib.h>
#include <gtk/gtk.h>

static void write_rc (gchar *newpath) {
	gchar *path_to_global_rc = "/root/.gtkrc-2.0";
	FILE *global_rc = fopen (path_to_global_rc, "w");
	fprintf (global_rc, "# -- THEME AUTO-WRITTEN DO NOT EDIT\ninclude \"%s\"\n\n", newpath);
	fprintf (global_rc, "include \"/root/.gtkrc.mine\"\n\n# -- THEME AUTO-WRITTEN DO NOT EDIT\n");
	fclose (global_rc);
}

int main (int argc, char *argv[]) {
	if (argc != 1) {
		gchar *theme = argv[1];
		gchar *suf = "gtkrc";
		if ((g_str_has_suffix (theme, suf)) && (g_file_test(theme, G_FILE_TEST_IS_REGULAR))){
			write_rc (theme);
		} else {
			gchar *path;
			path = g_strdup_printf ("/usr/share/themes/%s/gtk-2.0/gtkrc", theme);
			if (!g_file_test(path, G_FILE_TEST_IS_REGULAR)) {
				g_print("\n new-gtk2: Not a regular GTK-2 theme - %s \n", path);
			} else {
				write_rc (path);
			}
			g_free (path);
		}
	}
	gdk_init (&argc, &argv);
    GdkEventClient event = { GDK_CLIENT_EVENT, NULL, TRUE, gdk_atom_intern("_GTK_READ_RCFILES", FALSE), 8 };
    gdk_event_send_clientmessage_toall((GdkEvent *) &event);
}

